;--- Copyright (C) Sergei Frolov, 2002
;--- frs@overlink.ru    http://go.to/Frolov

;---     ---

;================================================
;---   
;---       78
;--- : r16, XL, XH
CHECK_INPUTS:
	sbrc	bitmap1, CLRSCR	; 1/2   ?
	rjmp	CLEAR_SCREEN	; 2	 -   

	in	r16, TWCR		; 1    I2C
	sbrc	r16, TWINT		; 1/2
	rjmp	os_6			; 2
	in	r16, UCSRA		; 1   UART
	sbrs	r16, RXC		; 2/1     UART?
	rjmp	os_0			; 2  -  
	in	r16, UDR		; 1  
	out	UDR, r16		; 1    UART
	nop				; 1
	nop				; 1
	nop				; 1
	nop				; 1
	nop				; 1
	nop				; 1
	nop				; 1
	nop				; 1
	rjmp	os_3			; 2

;---  I2C
os_6:	in	XH, TWSR		; 1    I2C
	cpi	XH, 0x80		; 1   ?
	breq	os_7			; 1/2  - 
	cpi	XH, 0x00		; 1  ?
	brne	os_8			; 2/1
	ldi	XL, 0b11010100
	rjmp	os_9

os_8:	ldi	XL, 0b11000100	; 1   I2C
	nop				; 1
os_9:	out	TWCR, XL		; 1
	out	portB, r16
	nop
	nop
	ldi	r16, 17		; 1
	rjmp	LAST_DELAY		; 
	
os_7:	in	r16, TWDR		; 1  	
	ldi	XL, 0b11000100	; 1   I2C
	out	TWCR, XL		; 1
	nop				; 1
	nop				; 1
	nop				; 1
	nop				; 1
	nop				; 1
	rjmp	os_3			; 2  
	
;---   
os_0:	in	r16, PINA		; 1  
	cp	r16, OLD_SYMBOL	; 1   ?
	brne	os_1			; 1/2  -  
;	nop				; 1
;	nop				; 1
	ldi	r16, 19		; 1
	rjmp	LAST_DELAY		; 2  
;--   
os_1:	out	portB, r16		; 1    ()
	nop				; 1
	cpi	r16, REPEAT_CODE	; 1  ?
	brne	os_2			; 2/1 
	mov	r16, OLD_SYMBOL	; 1   
	rjmp	os_3			; 2 
os_2:	mov	OLD_SYMBOL, r16	; 1   
	nop				; 1

;=================== 00 ===================
;---   (     )
os_3:	nop				; 1 sbi portX, bitX
	nop				; 1
	nop				; 1	 
	nop				; 1
;	nop				; 1
;	nop				; 1
;	nop				; 1
	nop				; 1
	nop				; 1
	nop				; 1
	nop				; 1
	eor	r16, const_0	; 1
	sbrc	bitmap1, C01_RCVD ; 2/1   C01?
	rjmp	detect_C01		; 2  -  
	sbrc	bitmap1, C02_RCVD ; 2/1   C02?
	rjmp	detect_C02		; 2  -  
	sbrc	bitmap1, ESC_RCVD ; 2/1   ESC?
	rjmp	detect_ESC		; 2  -  
	andi	bitmap1, 0b00011111 ; 1    
	cpi	r16, 0x20		; 1    ?
	brlo	NO_DISPLAY_SYMBOL	; 2/1  -   
	rjmp	DISPLAY_SYMBOL	; 2  -    

NO_DISPLAY_SYMBOL:
	cpi	r16, 0x1B		; 1  ESC?
	brne	noESC			; 2/1
	rjmp	DECODE_ESC		; 2
noESC:cpi	r16, 0x01		; 1	  CX?
	brne	no_01			; 2/1
	rjmp	DECODE_01		; 2
NO_01:cpi	r16, 0x02		; 1	  CY?
	brne	no_02			; 2/1
	rjmp	DECODE_02		; 2
NO_02:cpi	r16, 0x08		; 1
	brne	no_08			; 2/1
	rjmp	DECODE_08		; 2
NO_08:cpi	r16, 0x09		; 1
	brne	no_09			; 2/1
	rjmp	DECODE_09		; 2
NO_09:cpi	r16, 0x0A		; 1
	brne	no_0A			; 2/1
	rjmp	DECODE_0A		; 2
NO_0A:cpi	r16, 0x0C		; 1
	brne	no_0C			; 2/1
	rjmp	DECODE_0C		; 2
NO_0C:cpi	r16, 0x0D		; 1
	brne	no_0D			; 2/1
	rjmp	DECODE_0D		; 2

;---    
NO_0D:cpi	r16, 0x0F		; 1
	brne	NO_0F			; 1
	rjmp	start			; 

NO_0F:ldi	r16, 1		; 1
	rjmp	LAST_DELAY		; 2 (49)

;---    -   
DISPLAY_SYMBOL:			; (23)
	mov	XL, CY		; 1   
	clr	XH			; 1
	lsl	XL			; 1 *2
	rol	XH			; 1
	lsl	XL			; 1 *4
	rol	XH			; 1
	lsl	XL			; 1 *8
	rol	XH			; 1
	lsl	XL			; 1 *16
	rol	XH			; 1
	lsl	XL			; 1 *32
	rol	XH			; 1
	add	XL, CX		; 1
	adc	XH, const_0		; 1 
	add	XL, low_VIDEO_RAM	; 1
	adc	XH, const_0		; 1
	st	X+, r16		; 2    VIDEORAM
	inc	CX			; 1
	andi	CX, 0b00011111	; 1
	brne	os_4			; 2/1
	inc	CY			; 1
os_4:	cpi	CY, CHAR_Y		; 1
	brlo	os_5			; 1/2
	clr	CY			; 1
os_5:
;	andi	CY, 0b00011111	; 1
;	nop				; 1
	nop				; 1
	ldi	r16, 1		; 1 
	rjmp	LAST_DELAY		; 2 (47)

;--     
DECODE_01:				; (29)
	sbr	bitmap1, 1 << C01_RCVD ; 1
	nop
	ldi	r16, 7		; 1
	rjmp	LAST_DELAY		; 2 (33)

;--     
DECODE_02:				; (32)
	sbr	bitmap1, 1 << C02_RCVD ; 1
	nop				; 1
	ldi	r16, 6		; 1
	rjmp	LAST_DELAY		; 2 (36)

;--    
DECODE_08:				; (35)
	dec	CX			; 1
	cpi	CX, 0xFF		; 1
	brne	d08_1			; 2/1
	dec	CY			; 1
d08_1:andi	CX, 0x1F		; 1
	andi	CY, 0x1F		; 1
	nop				; 1
	nop				; 1
	ldi	r16, 3		; 1
	rjmp	LAST_DELAY		; 2 (44)

;--   
DECODE_09:				; (38)
	subi	CX, -8		; 1
	andi	CX, 0b00011000	; 1
	ldi	r16, 4		; 1
	rjmp	LAST_DELAY		; 2 (43)
	
;---    1
DECODE_0A:				; (41)
	inc	CY			; 1
	andi	CY, 0x1F		; 1
	ldi	r16, 3		; 1
	rjmp	LAST_DELAY		; 2 (46)

;---    1,1
DECODE_0C:				; (44)
	clr	CX			; 1
	clr	CY			; 1
	ldi	r16, low(SRAM)	; 1
	mov	CLS_CNT, r16	; 1
	clr	CLS_CNT2		; 1
	sbr	bitmap1, 1 << CLRSCR
	nop
	nop
	rjmp	LAST_DELAY_END	; 2 (52)

;---    
DECODE_0D:				; (47)
	clr	CX			; 1
	inc	CY			; 1
	andi	CY, 0x1F		; 1
	nop				; 1
	nop				; 1
	rjmp	LAST_DELAY_END	; 2 (53)

;---    ESC
DECODE_ESC:				; (26)
	sbr	bitmap1, 1 << ESC_RCVD ; 1
	nop				; 1
	ldi	r16, 8		; 1
	rjmp	LAST_DELAY		; 2 (30)
	
;---    CX
DETECT_C01:				; (15)
	mov	CX, r16		; 1   
	andi	bitmap1, 0b00011111 ; 1  bitmap1
	nop				; 1
	nop				; 1
	ldi	r16, 11		; 1  
	rjmp	LAST_DELAY		; 2 (20)    

;---    CY
DETECT_C02:				; (17)
	mov	CY, r16		; 1   
	andi	bitmap1, 0b00011111 ; 1  bitmap1
	ldi	r16, 11		; 1  
	rjmp	LAST_DELAY		; 2 (22)    

;---   ESC
DETECT_ESC:
	andi	bitmap1, 0b00011111 ; 1  bitmap1
	cpi	r16, 0x41		; 1
	brne	NO_41			; 2/1
	rjmp	DECODE_C41		; 2
NO_41:cpi	r16, 0x42		; 1
	brne	NO_42			; 2/1
	rjmp	DECODE_C42		; 1
NO_42:cpi	r16, 0x43		; 1
	brne	NO_43			; 2/1
	rjmp	DECODE_C43		; 1
NO_43:cpi	r16, 0x44		; 1
	brne	NO_44			; 2/1
	rjmp	DECODE_C44		; 1
NO_44:cpi	r16, 0x48		; 1
	brne	NO_48			; 2/1
	rjmp	DECODE_C48		; 1
NO_48:cpi	r16, 0x49		; 1
	brne	NO_49			; 2/1
	rjmp	DECODE_C49		; 1
NO_49:cpi	r16, 0x4A		; 1
	brne	NO_4A			; 2/1
	rjmp	DECODE_C4A		; 1
NO_4A:cpi	r16, 0x4B		; 1
	brne	NO_4B			; 2/1
	rjmp	DECODE_C4B		; 1

NO_4B:				; (44)
	nop				; 1
	nop				; 1
	ldi	r16, 2		; 1    
	rjmp	LAST_DELAY		; 2	(47)

;---  
DECODE_C41:				; (24)
	dec	CY			; 1
	cpi	CY, 0xFF		; 1
	brne	C41_1			; 2/1
	ldi	CY, CHAR_Y-1	; 1
c41_1:ldi	r16, 8		; 1
	rjmp	LAST_DELAY		; 2	(31)

;---  
DECODE_C42:				; (27)
	inc	CY			; 1
	andi	CY, 0x1F		; 1
	nop				; 1
	nop				; 1
	ldi	r16, 7		; 1
	rjmp	LAST_DELAY		; 2	(32)

;---  
DECODE_C43:				; (30)
	dec	CX			; 1
	cpi	CX, 0xFF		; 1
	brne	C43_1			; 2/1
	dec	CY			; 1
C43_1:andi	CX, 0x1F		; 1
	andi	CY, 0x1F		; 1
	nop				; 1
	ldi	r16, 5		; 1
	rjmp	LAST_DELAY		; 2	(39)

;---  
DECODE_C44:				; (33)
	inc	CX			; 1
	andi	CX, 0x1F		; 1
	brne	C44_1			; 2/1
	inc	CY			; 1
C44_1:andi	CX, 0x1F		; 1
	andi	CY, 0x1F		; 1
	nop				; 1
	ldi	r16, 4		; 1
	rjmp	LAST_DELAY		; 2	(42)

;---    
DECODE_C48:				; (36)
	clr	CX			; 1
	clr	CY			; 1
	ldi	r16, low(SRAM)	; 1
	mov	CLS_CNT, r16	; 1
	clr	CLS_CNT2		; 1
	sbr	bitmap1, 1 << CLRSCR ; 1
	nop				; 1
	ldi	r16, 3		; 1
	rjmp	LAST_DELAY		; 2	(42)

;---
DECODE_C49:				; (39)
	nop				; 1
	ldi	r16, 4		; 1
	rjmp	LAST_DELAY		; 2	(42)

;---    
DECODE_C4A:				; (42)
	sbr	bitmap1, 1 << CLREOS ; 1
	ldi	r16, 3		; 1
	rjmp	LAST_DELAY		; 2	(46)

;---    
DECODE_C4B:				; (45)
	sbr	bitmap1, 1 << CLREOL ; 1
	ldi	r16, 2		; 1
	rjmp	LAST_DELAY		; 2	(49)

;---  
LAST_DELAY:
	dec	r16			; 1
	brne	LAST_DELAY		; 2/1 r16*3-1
LAST_DELAY_END:
	ret

