; Begin:    15/01/2002
; End:v1.00 12/02/2002

;====             
;====       F R S 1 . 0 0

;--- Copyright (C) Sergei Frolov, 2002
;--- frs@overlink.ru    http://go.to/Frolov

;---    ,
;---       
;---  

;---     ---

;  m163def.inc    ASTUDIO
;     TabSize = 6

.nolist
.include "m163def.inc"
.list
;==========		============
.include "vid_var.asm"	   ;   ===========
;===============================  ==========
;==========	 	============
.include "vid_mac.asm"	   ;   ===========
;===============================  ==========
; ----   ----
.cseg
.org 0

start:
	jmp	RESET		; Reset Handler
	jmp	EXT_INT0 	; IRQ0 Handler
	jmp	EXT_INT1 	; IRQ1 Handler
	jmp	EXT_INT2 	; IRQ2 Handler
	.dw	0x940c
	.dw	0
	.dw	0x940c
	.dw	0xA0DB
	jmp	EXT_INT5 	; IRQ5 Handler
	jmp	EXT_INT6 	; IRQ6 Handler
	jmp	EXT_INT7 	; IRQ7 Handler
	jmp	TIM2_COMP 	; Timer2 Compare Handler
	jmp	TIM2_OVF 	; Timer2 Overflow Handler
	jmp	TIM1_CAPT 	; Timer1 Capture Handler
	jmp	TIM1_COMPA 	; Timer1 CompareA Handler
	jmp	TIM1_COMPB 	; Timer1 CompareB Handler
	jmp	TIM1_OVF 	; Timer1 Overflow Handler
	jmp	TIM0_COMP 	; Timer0 Compare Handler
	jmp	TIM0_OVF 	; Timer0 Overflow Handler
	jmp	SPI_STC 	; SPI Transfer Complete Handler
	jmp	UART_RXC 	; UART RX Complete Handler
	jmp	UART_DRE 	; UDR Empty Handler
	jmp	UART_TXC 	; UART TX Complete Handler
	jmp	ADC 		; ADC Conversion Complete Handler
	jmp	EE_RDY	; EEPROM Ready Handler
	jmp	ANA_COMP 	; Analog Comparator Handler

EXT_INT0:	; IRQ0 Handler
EXT_INT1:	; IRQ1 Handler
EXT_INT2:	; IRQ2 Handler
EXT_INT3:	; IRQ3 Handler
EXT_INT4:	; IRQ4 Handler
EXT_INT5:	; IRQ5 Handler
EXT_INT6:	; IRQ6 Handler
EXT_INT7:	; IRQ7 Handler
TIM2_COMP:	; Timer2 Compare Handler
TIM2_OVF:	; Timer2 Overflow Handler
TIM1_CAPT:	; Timer1 Capture Handler
TIM1_COMPA:	; Timer1 CompareA Handler
TIM1_COMPB:	; Timer1 CompareB Handler
TIM1_OVF:	; Timer1 Overflow Handler
TIM0_COMP:	; Timer0 Compare Handler
TIM0_OVF:	; Timer0 Overflow Handler
SPI_STC:	; SPI Transfer Complete Handler
UART_RXC:	; UART RX Complete Handler
UART_DRE:	; UDR Empty Handler
UART_TXC:	; UART TX Complete Handler
ADC: 		; ADC Conversion Complete Handler
EE_RDY:	; EEPROM Ready Handler
ANA_COMP:	; Analog Comparator Handler
	jmp	reset

COMMAND_RESET:		; FF 
reset:
	cli
	ldi	r16, high(RAMEND)		 ;  
	out	SPH, r16
	ldi	r16, low(RAMEND);
	out	SPL, r16
	clr	bitmap1
	clr	bitmap2
	clr	CX			; 1
	clr	CY			; 1
	clr	OLD_SYMBOL		; 1
	clr	LINE_NUM		; 1
	clr	LINES_CNT		; 1
	clr	const_0
	clr	const_FF
	ldi	r16, low(VIDEO_RAM)
	mov	low_VIDEO_RAM, r16

;---  
	ldi	r16, 0b00000000	;   -   ,
	out	DDRA, r16		;  
	ldi	r16, 0b11111111
	out	portA, r16
	ldi	r16, 0b11111111	;  B -   
	out	DDRB, r16
	ldi	r16, 0b11111111	;  
	out	portB, r16
	ldi	r16, 0b10000000	;  C -    PC7
	out	DDRC, r16
	ldi	r16, 0b00000000
	out	portC, r16
	ldi	r16, 0b11000010	;  D
	out	DDRD, r16
	ldi	r16, 0b00000001	
	out	portD, r16

;---  UART  9600
	ldi	r16, 103
	out	UBRR, r16
	clr	r16
	out	UBRRHI, r16
	ldi	r16, 0b00011000	; RXCIE TXCIE UDRIE RXEN TXEN CHR9 RXB8 TXB8
	out	UCSRB, r16

	ldi	r16, low((CHAR_GEN << 1)-(0x20*8))	;   
	mov	CHGEN, r16
	ldi	r16, high((CHAR_GEN << 1)-(0x20*8))
	mov	CHGEN_H, r16

;---  I2C
	ldi	r16, 0b11000100	; TWINT,TWEA,TWSTA,TWSTO,TWWC,TWEN,-,TWIE
	out	TWCR, r16		; 
	ldi	r16, 0b01000110	;  0x46
	out	TWAR, r16

;---  SRAM
	ldi	ZL, low(SRAM)
	ldi	ZH, high(SRAM)
	ldi	r16, 0x20	;  
cs_1:	st	Z+, r16
	cpi	ZL, low(RAMEND)
	brne	cs_1
	cpi	ZH, high(RAMEND)
	brne	cs_1

;---  
	ldi	ZL, low(text1 << 1)
	ldi	ZH, high(text1 << 1)
	rcall	show_text
	ldi	ZL, low(text2 << 1)
	ldi	ZH, high(text2 << 1)
	rcall	show_text
	ldi	ZL, low(text3 << 1)
	ldi	ZH, high(text3 << 1)
	rcall	show_text
	ldi	ZL, low(text4 << 1)
	ldi	ZH, high(text4 << 1)
	rcall	show_text
	ldi	ZL, low(text5 << 1)
	ldi	ZH, high(text5 << 1)
	rcall	show_text
	in	OLD_SYMBOL, PINA	;    
	
;---   CONST_0  CONST_FF
	clr	ZL
	clr	ZH
	ldi	r17, 5
	clr	r16
	mov	r0, const_0
chc_1:lpm	r0, Z+
	lpm	r1, Z+
	eor	const_0, r0
	eor	const_FF, r1
	inc	r16
	brne	chc_1
	dec	r17
	brne	chc_1
	out	PORTC, CONST_0	; 1 .

LOOP:
;= 623 == 0:80,1:432,0:40,1:472 ========================
; 	out	PORTD, CONST_0	; 1 .
	ldi	r21, 13		;  4.75 us
	rcall	DELAY_V
	eor	r21, const_0
	nop
	nop
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_436		;  432 
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474
;= 624 == 0:40,1:472,0:40,1:472 ========================
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  80 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  432 
;= 625 == 0:40,1:472,0:40,1:472 ========================
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  80 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
;=   1 == 0:432,1:80,0:432,1:80 ========================
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_436		;  432 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_76		;  80 
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_436		;  432 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_76		;  80 
;=   2 == 0:432,1:80,0:432,1:80 ========================
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_436		;  432 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_76		;  80 
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_436		;  432 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_76		;  80 
;=   3 == 0:432,1:80,0:40,1:472 ========================
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_436		;  432 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_76		;  80 
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
;=   4 == 0:40,1:472,0:40,1:472 ========================
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
;=   5 == 0:40,1:472,0:40,1:472 ========================
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
;================================================
 	out	PORTD, CONST_0	; 1 .
	rcall	SHOW_TEXT_BODY
;================================================
	
;= 310 =========================================
	ldi	r21, 14
	rcall	DELAY_V
	eor	r21, const_0
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_948		;  472 

;= 311 == 0:40,1:472,0:40,1:472 ========================
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
;= 312 == 0:40,1:472,0:40,1:472 ========================
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
;= 313 == 0:40,1:472,0:432,1:80 ========================
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_436		;  432 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_76		;  80 
;= 314 == 0:432,1:80,0:432,1:80 ========================
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_436		;  432 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_76		;  80 
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_436		;  432 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_76		;  80 
;= 315 == 0:432,1:80,0:432,1:80 ========================
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_436		;  432 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_76		;  80 
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_436		;  432 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_76		;  80 
;= 316 == 0:40,1:472,0:40,1:472 ========================
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
;= 317 == 0:40,1:472,0:40,1:472 ========================
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_474		;  472 
;= 318 == 0:40,1:984            ========================
 	out	PORTD, CONST_0	; 1 .
	rcall DELAY_38		;  40 
	out	PORTD, CONST_FF	; 1 . 
	rcall DELAY_986		;  944 
;= 319 == 0:80,1:944            ========================
; 	out	PORTD, CONST_0	; 1 .
;	rcall DELAY_76		;  40 
;	out	PORTD, CONST_FF	; 1 . 
;	rcall DELAY_944		;  944 
; 	out	PORTD, CONST_0	; 1 .
;================================================
 	out	PORTD, CONST_0	; 1 .
	rcall	SHOW_TEXT_BODY
;================================================
	rjmp	LOOP
	
;=====     =====
text1:.dw	11 + 0*32 + VIDEO_RAM
	.db	9, "VIDEOTEXT"
text2:.dw	12 + 2*32 + VIDEO_RAM
	.db	7, "FRS1.00"
text4:.dw	6 + 11*32 + VIDEO_RAM
	.db	19, "http://go.to/Frolov"
text3:.dw	4 + 26*32 + VIDEO_RAM
	.db	23, "(C) Sergei Frolov, 2002"
text5:.dw	8 + 28*32 + VIDEO_RAM
	.db	15, "frs@overlink.ru"

;======    ============
.include "vid_body.asm"	   ;   ===========
;===============================  ==========

;======    ============
.include "vid_code.asm"	   ;   ===========
;===============================  ==========

;==========	    ============
.include "vid_sub.asm"	   ;   ===========
;===============================  ==========

;==========	          ==========
.include "vid_fnt.asm"	   ;   ===========
;===============================  ==========

